#ifndef _PANE_H
#define _PANE_H
/*************************************************************************
 * File: $Source$
 * Author: Jan Newmarch
 * Last modified: $Date$
 * Version: $Revision$
 * Purpose: public header file for Pane objects
 *
 * Revision history:
 ************************************************************************/ 

/*************************************************************************
 * System includes
 ************************************************************************/ 
#include <X11/Intrinsic.h>

/*************************************************************************
 * Local includes
 ************************************************************************/ 
#include "types.h"

/*************************************************************************
 * Constants
 ************************************************************************/ 

/*************************************************************************
 * Data types
 ************************************************************************/ 

/*************************************************************************
 * Functions exported
 ************************************************************************/ 
void
PaneResized (
#ifdef UseFunctionPrototypes
        Widget w, XEvent *event, char **args, Cardinal *num_args
#endif
);

Widget
PaneCreate (
#ifdef UseFunctionPrototypes
        Widget parent, Widget *pane, char *name, Widget *filter, 
                char *filter_label, dir_pane_info *dpi
#endif
);
  
void
DirPaneShow (
#if UseFunctionPrototypes
        dir_pane_info *dpi
#endif
);
  
void
ExecutablePaneShow (
#if UseFunctionPrototypes
        dir_pane_info *dpi
#endif
);
  
void
DirPaneShow (
#if UseFunctionPrototypes
        dir_pane_info *dpi
#endif
);
  
void
DirPaneUnshow (
#if UseFunctionPrototypes
        dir_pane_info *dpi
#endif
);
  
void
ExecutablePaneUnshow (
#if UseFunctionPrototypes
        dir_pane_info *dpi
#endif
);
  
void
DirPaneUnshow (
#if UseFunctionPrototypes
        dir_pane_info *dpi
#endif
);

void
DirPaneAddFile (
#if UseFunctionPrototypes
        char * filename, dir_pane_info *dpi
#endif
);

void
ExecutablePaneAddFile (
#if UseFunctionPrototypes
        char * filename, dir_pane_info *dpi
#endif
);

void
FilePaneAddFile (
#if UseFunctionPrototypes
        char * filename, dir_pane_info *dpi
#endif
);


/*************************************************************************
 * Variables exported
 ************************************************************************/ 

#endif /* _PANE_H */
